﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SokobanTest
{
    class Program
    {
        private static int[,] _bana =
        {
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 0, 0, 0, 0, 1, 0, 1, 1, 1},
            {1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
            {1, 0, 0, 0, 1, 0, 0, 0, 0, 1},
            {1, 0, 1, 0, 0, 0, 0, 0, 2, 1},
            {1, 0, 1, 0, 0, 0, 0, 0, 0, 1},
            {1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
        };

        private static int[,] _stenar =
        {
            {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
            {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
            {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
            {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
            {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
            {0, 0, 0, 0, 0, 0, 1, 0, 0, 0},
            {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
            {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        };

        private static int spelareX = 1;
        private static int spelareY = 1;

        static void Main(string[] args)
        {
            while (true)
            {
                RitaBana();
                var vunnit = KollaVinst();
                if (vunnit)
                    Console.WriteLine("BANAN AVKLARAD!");

                var key = Console.ReadKey();

                int deltaX = 0;
                int deltaY = 0;

                switch (key.Key)
                {
                    case ConsoleKey.LeftArrow:
                        deltaX = -1;
                        break;
                    case ConsoleKey.RightArrow:
                        deltaX = 1;
                        break;
                    case ConsoleKey.DownArrow:
                        deltaY = 1;
                        break;
                    case ConsoleKey.UpArrow:
                        deltaY = -1;
                        break;
                }


                if (_stenar[spelareY + deltaY, spelareX + deltaX] == 0)
                {
                    if (_bana[spelareY + deltaY, spelareX + deltaX] != 1)
                    {
                        spelareX += deltaX;
                        spelareY += deltaY;
                    }
                }
                else //går mot en sten!
                {
                    if (_bana[spelareY + deltaY*2, spelareX + deltaX*2] != 1 && 
                        _stenar[spelareY + deltaY*2, spelareX + deltaX*2] == 0)
                    {
                        _stenar[spelareY + deltaY, spelareX + deltaX] = 0;
                        _stenar[spelareY + deltaY*2, spelareX + deltaX*2] = 1;
                        spelareX += deltaX;
                        spelareY += deltaY;
                    }
                }

                Console.Clear();

            }
        }

        private static bool KollaVinst()
        {
            for (int y = 0; y < 8; y++)
            {
                for (int x = 0; x < 10; x++)
                {
                    if (_bana[y, x] == 2 && _stenar[y, x] != 1)
                        return false;
                }
            }

            return true;
        }

        private static void RitaBana()
        {
            for (int y = 0; y < 8; y++ )
            {
                for (int x = 0; x < 10; x++)
                {
                    if (x == spelareX && y == spelareY)
                        Console.Write("@");
                    else if (_stenar[y, x] == 1)
                        Console.Write("*");
                    else if (_bana[y, x] == 1)
                        Console.Write("#");
                    else if (_bana[y, x] == 0)
                        Console.Write(" ");
                    else if (_bana[y, x] == 2)
                        Console.Write("$");
                }
                Console.WriteLine();
            }
        }
    }
}
